<script>
import { ref, reactive } from "vue";
import store from "@/store"
import useValidate from "@vuelidate/core";
import { required } from "@vuelidate/validators";
import { HTTP } from "@/components/common/HttpCommon";

import Loading from '@/components/item/Loading.vue';
export default {
  components: { Loading },
  name: 'SignUp',
  props: {
  },
  setup() {
    const data = ref(null);
    const loading = ref(false);
    const error = ref(null);
    const state = reactive({
            username : '',
            password : '',
            rememberme : false
         });
    const rules = {
            username : { required },
            password : { required }
         }
    const v$ = useValidate(rules, state)
    async function doLogin() {
      loading.value = true;
      const requestData = {
               username : state.username,
               password : state.password
            }
      const result = await HTTP.post(`login`, JSON.stringify( requestData )).then(response => {
            localStorage.token = response.data.token
            localStorage.rememberme = state.rememberme
            store.state.rememberMe = state.rememberme
            data.value = "Sign-in is Successful. "
            setTimeout(() => {
               this.doSignIn()
            },500);
         })
         .catch(e => {
            const jsonError = e.toJSON();
            error.value = jsonError.message
         })
      loading.value = false;
    }

    return {
      data,
      loading,
      error,
      state,
      v$,
      doLogin
    };
  },
  methods: {
   submitForm() {
      this.v$.$validate()
      if(!this.v$.$error){
         this.doLogin()
      }
   },
   doSignIn(){
      localStorage.logined = !store.state.isLogin
      store.commit('setIsLogin')
      location.reload();
   },
   doSignUp(){
      localStorage.signup = !store.state.signup
      store.commit('togleSignUp')
      location.reload();
   }
  }
}
</script>

<template>
  <Loading v-if="loading" />
  <div class="wrapper" v-if="!loading">
    <section class="login-content">
       <b-form  @submit="submitForm">
       <div class="container">
          <div class="row align-items-center justify-content-center height-self-center">
             <div class="col-lg-8">
                <div class="card auth-card">
                   <div class="card-body p-0">
                      <div class="d-flex align-items-center auth-content">
                         <div class="col-lg-7 align-self-center">
                            <div class="p-3">
                              <h2 class="mb-2">Sign In</h2>
                              <p>Login to stay connected.</p>
                              <div class="row">
                                <div class="col-lg-12">
                                   <div class="alert bg-white alert-danger" role="alert" v-if="v$.$error || error" >
                                      <div class="iq-alert-icon">
                                         <i class="ri-information-line"></i>
                                      </div>
                                      <div class="iq-alert-text">
                                         <span v-if="v$.username.$error"> Field Username {{v$.username.$errors[0].$message}}<br /></span>
                                         <span v-if="v$.password.$error"> Field Password {{v$.password.$errors[0].$message}}<br /></span>
                                         <span v-if="error"> {{error}}</span>
                                      </div>
                                   </div>
                                   <div class="alert bg-white alert-secondary" role="alert" v-if="data">
                                      <div class="iq-alert-text">{{data}}</div>
                                   </div>
                                </div>
                                <div class="col-lg-12">
                                   <div class="floating-label form-group">
                                      <input v-model="state.username" class="floating-input form-control" placeholder=" " :class="{'is-invalid' : v$.username.$error }">
                                      <label>Username</label>
                                   </div>
                                </div>
                                <div class="col-lg-12">
                                   <div class="floating-label form-group">
                                      <input v-model="state.password" class="floating-input form-control" type="password" placeholder=" " :class="{'is-invalid' : v$.password.$error }">
                                      <label>Password</label>
                                   </div>
                                </div>
                                <div class="col-lg-6">
                                   <div class="custom-control custom-checkbox mb-3">
                                      <input v-model="state.rememberme" type="checkbox" class="custom-control-input" id="customCheck1" >
                                      <label class="custom-control-label control-label-1" for="customCheck1">Remember Me</label>
                                   </div>
                                </div>
                                <div class="col-lg-6">
                                   <a href="#" class="text-primary float-right">Forgot Password?</a>
                                </div>
                              </div>
                              <button type="submit" class="btn btn-primary" @click="submitForm">Sign In</button>
                              <p class="mt-3">
                                 Create an Account <a href="#signup" class="text-primary" @click="doSignUp" >Sign Up</a>
                              </p>
                            </div>
                         </div>
                         <div class="col-lg-5 content-right">
                            <img src="../assets/images/login/01.png" class="img-fluid image-right" alt="">
                         </div>
                      </div>
                   </div>
                </div>
             </div>
          </div>
       </div>
       </b-form>
    </section>
  </div>
</template>

<style scoped>
.control-label-1{
   cursor: pointer;
}
</style>
